#ifndef _ygGeometry_h_
#define _ygGeometry_h_

#include "ygNode.h"

#define DRAW_OFF 0
#define DRAW_ON 1
#define DRAW_LOCAL 2
#define DRAW_REMOTE 3

class pfNode;

class ygGeometry : public ygNode
    {
    public:
     ygGeometry(const char* name,bool master=true);
     ~ygGeometry(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
         void setWall(bool);
         void setFloor(bool);
         void setDraw(int);
         void setCull(int);
         void setWireframe(bool);
    protected:
     int draw;
     bool wall;
     bool floor;
     bool wireframe;
     int cull;
    private:
     void setGeoState(uint64_t,int,pfNode*);
     uint isectMask;
    };

extern "C" ygNode* construct_ygGeometry(const char* name,bool master);

#endif
